> ## Documentation Index
> Fetch the complete documentation index at: https://docs-staging-quickstart-revamp.mintlify.site/llms.txt
> Use this file to discover all available pages before exploring further.

> Learn about released versions of Actions, including breaking changes and new features.

# Releases

Features and breaking changes released in Actions are listed below.

## v3

### Login Flow

New features and breaking changes were released to triggers in the Login Flow. To learn about these changes, read [Login Flow: Releases](/docs/releases).

## v2 (GA)

### Query and body parameters

Direct access to the query and body parameters is available using the `event.request.query` and `event.request.body` objects. These are exposed regardless of whether the authorization was initiated via a `GET` or `POST` request. Many protocol-specific query or body parameters sent as part of an authorization request are now also available as first-class values on the `event.transaction` object. We recommend that you use `event.transaction` rather than `event.request.query` and `event.request.body` unless your use case is not supported. A complete mapping of these changes is below:

<table class="table">
  <thead>
    <tr>
      <th>Pre-GA Property</th>
      <th>GA Property</th>
    </tr>
  </thead>

  <tbody>
    <tr>
      <td><code>event.actor.ip</code></td>
      <td><code>event.request.ip</code></td>
    </tr>

    <tr>
      <td><code>event.actor.hostname</code></td>
      <td><code>event.request.hostname</code></td>
    </tr>

    <tr>
      <td><code>event.actor.geoIp</code></td>
      <td><code>event.request.geoip</code></td>
    </tr>

    <tr>
      <td><code>event.actor.language</code></td>
      <td><code>event.request.language</code></td>
    </tr>

    <tr>
      <td><code>event.actor.method</code></td>
      <td><code>event.request.method</code></td>
    </tr>

    <tr>
      <td><code>event.actor.userAgent</code></td>
      <td><code>event.request.user\_agent</code></td>
    </tr>

    <tr>
      <td><code>event.actor.body</code></td>
      <td><code>event.request.body</code></td>
    </tr>

    <tr>
      <td><code>event.actor.query</code></td>
      <td><code>event.request.query</code></td>
    </tr>

    <tr>
      <td><code>event.actor.query.audience</code></td>
      <td><code>event.resource\_server.identifier</code></td>
    </tr>

    <tr>
      <td><code>event.actor.query.scope</code></td>
      <td><code>event.transaction.requested\_scopes</code></td>
    </tr>

    <tr>
      <td><code>event.actor.query.acr\_values</code></td>
      <td><code>event.transaction.acr\_values</code></td>
    </tr>

    <tr>
      <td><code>event.actor.query.ui\_locales</code></td>
      <td><code>event.transaction.ui\_locales</code></td>
    </tr>

    <tr>
      <td><code>event.protocol</code></td>
      <td><code>event.transaction.protocol</code></td>
    </tr>

    <tr>
      <td><code>context.secrets</code></td>
      <td><code>event.secrets</code></td>
    </tr>
  </tbody>
</table>

### User Profile properties

In general, the `event.user` object has had its properties changed from camel case to snake case in order to match the [Auth0 User Profile structure](/docs/manage-users/user-accounts/user-profiles/user-profile-structure). For example, `event.user.appMetadata` has been changed to `event.user.app_metadata`.

### Performing side effects

In the pre-GA version of the post-login trigger, side effects were performed by returning an object from an Action. In Actions GA, an `api` object is provided to encapsulate these changes and provide better in-editor type hints and inline documentation.

To learn more about these changes and see code examples, read [Login Flow: Releases](/docs/releases).

### Manipulating scopes

Although we experimented with providing direct manipulation of ID and <Tooltip tip="Access Token: Authorization credential, in the form of an opaque string or JWT, used to access an API." cta="View Glossary" href="/docs/glossary?term=Access+Token">Access Token</Tooltip> scopes during the Actions Beta, we do not support this functionality in Actions GA.
